<?php
if (!function_exists('sql_table'))
{
   function sql_table($name) {
      return 'nucleus_' . $name;
   }
}

class NP_NewMemberBlog extends NucleusPlugin {
   function getEventList() { return array('PostRegister'); }
   function getName() { return 'Weblog AutoCreate'; }
   function getAuthor() { return 'Frankenstein'; }
   function getURL() { return 'http://www.yoursite.com/'; }
   function getVersion() { return '1.1'; }
   function supportsFeature($what) {
      switch($what)
      { case 'SqlTablePrefix':
            return 1;
         default:
            return 0; }
   }
   
   function getDescription() { return 'Member weblog autocreation.'; }
   function install() {
      $this->createOption('siteurl','URL of Site: Normal (end with slash /) - Fancy (do not end with slash)','text','http://www.yourblog.com');
   }
   
   function event_PostRegister($data) {
      //This function borrows heavily from ADMIN::action_addnewlog()
      //There are a couple reasons ADMIN::action_addnewlog() isn't being used.
      //First, the data used is stored in the POST variables.
      //Second, the member creating is assumed to be the global $member
      //and that member needs to be a superadmin.
     
      global $manager, $CONF;
     
      $manager->loadClass("PARSER");//Needed for BaseActions so BLOG.php loads
     
      $memberid=$data['member']->getID();
     
      $bname=$data['member']->getRealName()."'s Weblog";
      $bshortname=$data['member']->getDisplayName();//Fitting 16 chars into a 15 char field, but...
      $btimeoffset=0;
      $bdesc='Autogenerated weblog for '.$bshortname;
      $bdefskin=quickQuery('SELECT bdefskin as result FROM '.sql_table('blog')." WHERE bnumber='{$CONF['DefaultBlog']}'");
     
      if ($manager->existsBlog($bshortname)){
         ACTIONLOG::add(WARNING, 'NP_NewMemberBlog: Unable to autocreate weblog for '.$bshortname.' as a log by that name already exists');
         return;
      }
     
      $manager->notify(
         'PreAddBlog',
         array(
            'name' => &$bname,
            'shortname' => &$bshortname,
            'timeoffset' => &$btimeoffset,
            'description' => &$bdescription,
            'defaultskin' => &$bdefskin
         )
      );


      // add slashes for sql queries
      $bname =       addslashes($bname);
      $bshortname =    addslashes($bshortname);
      $btimeoffset =    addslashes($btimeoffset);
      $bdesc =       addslashes($bdesc);
      $bdefskin =    addslashes($bdefskin);
     
      // create blog
      $query = 'INSERT INTO '.sql_table('blog')." (bname, bshortname, bdesc, btimeoffset, bdefskin) VALUES ('$bname', '$bshortname', '$bdesc', '$btimeoffset', '$bdefskin')";
      sql_query($query);
      $blogid   = mysql_insert_id();
      $blog   =& $manager->getBlog($blogid);
     
      // create new category
      sql_query('INSERT INTO '.sql_table('category')." (cblog, cname, cdesc) VALUES ($blogid, 'Daily Updates','Items that do not fit in other categories')");
      $catid = mysql_insert_id();

      // set as default category
      $blog->setDefaultCategory($catid);
      //add URL for the blog
$blog_url = $this->getOption('siteurl');
$blog_url = $this->getOption('siteurl');

$blog_url = $blog_url.createBlogidLink($blogid);

$blog->setURL($blog_url);
      //And write
      $blog->writeSettings();
   
      // create team member   
      $query = 'INSERT INTO '.sql_table('team')." (tmember, tblog, tadmin) VALUES ($memberid, $blogid, 1)";
      sql_query($query);

      $blog->additem($blog->getDefaultCategory(),'First Item For This Author!','This is the first item in the Friends & Family Blog for this author!  This item can be deleted in the admin area, or changed to reflect what information you want in your post!  Look forward to seeing the rest of your posts!','',$blogid, $memberid,$blog->getCorrectTime(),0,0,0);
     
      $manager->notify(
         'PostAddBlog',
         array(
            'blog' => &$blog
         )
      );
     
      $manager->notify(
         'PostAddCategory',
         array(
            'catid' => $catid
         )
      );
      ACTIONLOG::add(INFO, 'NP_NewMemberBlog: Weblog for '.$bshortname.' autogenerated');
   }
}
?>
